//----------------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#ifndef COLORSETTINGH
#define COLORSETTINGH
//----------------------------------------------------------------------------
#include <System.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Graphics.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include "main.h"
//----------------------------------------------------------------------------
class TColorSettingDlg : public TForm
{
__published:
	TButton *OKBtn;
	TBevel *Bevel1;
	TColorDialog *ColorDialog;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label3;
	TLabel *Label4;
	TEdit *Edit1;
	TEdit *Edit2;
	TEdit *Edit3;
	TEdit *Edit4;
	TButton *Button1;
	TButton *Button2;
	TButton *Button3;
	TButton *Button4;
	TButton *Button5;
	void __fastcall Button1Click(TObject *Sender);
private:
public:
	virtual __fastcall TColorSettingDlg(TComponent* AOwner);
	inline TColor GetColor(int n) const { return Color[n]; }
	inline void SetColor(int n, TColor c) { Color[n] = c; Edits[n]->Font->Color = c; }
private:
	TColor Color[TMainForm::COLOR_MAX];
	TEdit* Edits[TMainForm::COLOR_MAX];
};
//----------------------------------------------------------------------------
extern PACKAGE TColorSettingDlg *ColorSettingDlg;
//----------------------------------------------------------------------------
#endif
