//---------------------------------------------------------------------------
#ifndef ProtoH
#define ProtoH

#ifndef COUNTOF
#define COUNTOF(x) (sizeof(x)/sizeof(x[0]))
#endif
inline WORD ntohs(LPBYTE pb) { return (WORD)((*pb << 8) | *(pb + 1)); }
inline DWORD ntohl(LPBYTE pb) { return (DWORD)((*pb << 24) | (*(pb + 1) << 16) | (*(pb + 2) << 8) | *(pb + 3)); }
inline WORD ntohs(WORD w) { return (WORD)((w >> 8) | ((w & 0xff) << 8)); }

enum TCP_CONTROLBITS {
	TCP_URG = 0x20,
	TCP_ACK = 0x10,
	TCP_PSH = 0x08,
	TCP_RST = 0x04,
	TCP_SYN = 0x02,
	TCP_FIN = 0x01,
};

const int SUPPORTED_OSPF_VERSION = 2;
const int OSPF_HLEN = 24;

#endif
