// Copyright(c) 1999 arton	

#ifndef __NAMEVALUEPAIR_H_
#define __NAMEVALUEPAIR_H_

#include "resource.h"

/////////////////////////////////////////////////////////////////////////////
// CNameValuePair
class ATL_NO_VTABLE CNameValuePair : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CNameValuePair, &CLSID_NameValuePair>,
	public IDispatchImpl<INameValuePair, &IID_INameValuePair, &LIBID_MACCAPV2Lib, MACCAPLIB_MJ>
{
public:
	CNameValuePair()
	{
		m_pUnkMarshaler = NULL;
		VariantInit(&m_value);
	}

DECLARE_REGISTRY_RESOURCEID(IDR_NAMEVALUEPAIR)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CNameValuePair)
	COM_INTERFACE_ENTRY(INameValuePair)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		VariantClear(&m_value);
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

	std::wstring m_strName;
	VARIANT m_value;
// INameValuePair
public:
	HRESULT STDMETHODCALLTYPE get_Value( 
            /* [retval][out] */ VARIANT __RPC_FAR *pRetVal);
        
	HRESULT STDMETHODCALLTYPE put_Value( 
            /* [in] */ VARIANT NewVal);
        
	HRESULT STDMETHODCALLTYPE get_Name( 
            /* [retval][out] */ BSTR __RPC_FAR *pRetVal);
        
	HRESULT STDMETHODCALLTYPE put_Name( 
            /* [in] */ BSTR NewVal);
};

#endif //__NAMEVALUEPAIR_H_
