//---------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#include <vcl.h>
#pragma hdrstop

#include "AddressSet.h"
//---------------------------------------------------------------------
#pragma link "IPMaskEdit"
#pragma resource "*.dfm"
TAddressInputDlg *AddressInputDlg;
//--------------------------------------------------------------------- 
__fastcall TAddressInputDlg::TAddressInputDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------
void TAddressInputDlg::SetDefault(TAddressInputDlg::DirectionType dt, AnsiString& as)
{
	switch (dt)
	{
	case DT_BI:
		RadioBtnBi->Checked = true;
		break;
	case DT_SRC:
		RadioBtnSrc->Checked = true;
		break;
	default:
		RadioBtnDst->Checked = true;
		break;
	}
	MaskEdit->Text = as;
}
//---------------------------------------------------------------------
void TAddressInputDlg::InitDlg(bool IP)
{
	MaskEdit->SetAddressType(IP);
	IPMode = IP;
	if (IP)
	{
		Caption = "IP Address";
		Label->Caption = "IP Address";
	}
	else
	{
		Caption = "MAC Address";
		Label->Caption = "MAC Address";
	}
}
//---------------------------------------------------------------------
void __fastcall TAddressInputDlg::FormCloseQuery(TObject *Sender,
	  bool &CanClose)
{
	CanClose = false;
	if (ModalResult == mrOk)
	{
		MaskEdit->CheckAddress();
		ResultString = MaskEdit->GetResultString();
	}
	CanClose = true;
}
//---------------------------------------------------------------------------
int TAddressInputDlg::GetDirection()
{
	if (RadioBtnBi->Checked)
		return DT_BI;
	if (RadioBtnSrc->Checked)
		return DT_SRC;
	return DT_DST;
}
//---------------------------------------------------------------------------







