//----------------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#ifndef OCBH
#define OCBH
//----------------------------------------------------------------------------
#include <System.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Graphics.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include "MACCAPLib_TLB.h"
//----------------------------------------------------------------------------
class TCapFilterDlg : public TForm
{
__published:
	TButton *OKBtn;
	TButton *CancelBtn;
	TTabControl *TabControl;
	TButton *ButtonAdd;
	TButton *ButtonEdit;
	TButton *ButtonDelete;
	TListBox *ListBox;
	void __fastcall ButtonAddClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall TabControlChange(TObject *Sender);
	void __fastcall ButtonDeleteClick(TObject *Sender);
	void __fastcall ButtonEditClick(TObject *Sender);
private:
	TStringList* MacList;
	TStringList* IPAddrList;
	TStringList* ProtList;
public:
	enum {
		MAC_PAGE = 0,
		IPA_PAGE = 1,
		IPP_PAGE = 2,
	};
	virtual __fastcall TCapFilterDlg(TComponent* AOwner);
	inline void SetLists(TStringList* pMac, TStringList* pIP, TStringList* pProt)
	{
		MacList = pMac;
		IPAddrList = pIP;
		ProtList = pProt;
	}
};
//----------------------------------------------------------------------------
extern PACKAGE TCapFilterDlg *CapFilterDlg;
//----------------------------------------------------------------------------
#endif
