// Copyright(c) 1999 arton

#include "stdafx.h"
#include "MacCapv2.h"
#include "NameValuePair.h"

/////////////////////////////////////////////////////////////////////////////
// CNameValuePair

HRESULT STDMETHODCALLTYPE CNameValuePair::get_Value( 
            /* [retval][out] */ VARIANT __RPC_FAR *pRetVal)
{
	if (!pRetVal) return E_POINTER;
	VariantClear(pRetVal);
	VariantCopy(pRetVal, &m_value);
	return S_OK;
}
        
HRESULT STDMETHODCALLTYPE CNameValuePair::put_Value( 
            /* [in] */ VARIANT NewVal)
{
	VariantClear(&m_value);
	VariantCopy(&m_value, &NewVal);
	return S_OK;
}
        
HRESULT STDMETHODCALLTYPE CNameValuePair::get_Name( 
            /* [retval][out] */ BSTR __RPC_FAR *pRetVal)
{
	if (!pRetVal) return E_POINTER;
	*pRetVal = SysAllocString(m_strName.c_str());
	return S_OK;
}
        
HRESULT STDMETHODCALLTYPE CNameValuePair::put_Name( 
            /* [in] */ BSTR NewVal)
{
	m_strName = (NewVal) ? NewVal : L"";
	return S_OK;
}

